## Create a Target configuration for tenant.

### cURL

```
curl --request POST \
  --url https://prod01.oms.fabric.inc/api/v2/configurations/target-config \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --header 'x-site-context: <x-site-context>' \
  --data '
{
  "serviceName": "order-service",
  "processName": "order-create",
  "targetService": [\
    {\
      "serviceName": "NOTIFICATION_SERVICE",\
      "serviceAttributes": {}\
    }\
  ]
}
'
```

### Python

```
import requests

url = "https://prod01.oms.fabric.inc/api/v2/configurations/target-config"

payload = {
    "serviceName": "order-service",
    "processName": "order-create",
    "targetService": [
        {
            "serviceName": "NOTIFICATION_SERVICE",
            "serviceAttributes": {}
        }
    ]
}
headers = {
    "x-site-context": "<x-site-context>",
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
```

### JavaScript (Fetch)

```
const options = {
  method: 'POST',
  headers: {
    'x-site-context': '<x-site-context>',
    Authorization: 'Bearer <token>',
    'Content-Type': 'application/json'
  },
  body: JSON.stringify({
    serviceName: 'order-service',
    processName: 'order-create',
    targetService: [{serviceName: 'NOTIFICATION_SERVICE', serviceAttributes: {}}]
  })
};

fetch('https://prod01.oms.fabric.inc/api/v2/configurations/target-config', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));
```

### PHP

```
<?php

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://prod01.oms.fabric.inc/api/v2/configurations/target-config",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "POST",
  CURLOPT_POSTFIELDS => json_encode([
    'serviceName' => 'order-service',
    'processName' => 'order-create',
    'targetService' => [
        [
                'serviceName' => 'NOTIFICATION_SERVICE',
                'serviceAttributes' => [

]
        ]
    ]
  ]),
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer <token>",
    "Content-Type: application/json",
    "x-site-context: <x-site-context>"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}
?>
```

### Go

```
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

url := "https://prod01.oms.fabric.inc/api/v2/configurations/target-config"

payload := strings.NewReader("{\n  \"serviceName\": \"order-service\",\n  \"processName\": \"order-create\",\n  \"targetService\": [\n    {\n      \"serviceName\": \"NOTIFICATION_SERVICE\",\n      \"serviceAttributes\": {}\n    }\n  ]\n}")

req, _ := http.NewRequest("POST", url, payload)

req.Header.Add("x-site-context", "<x-site-context>")
	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

res, _ := http.DefaultClient.Do(req)

defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))
}
```

### Examples of Responses

- **200 OK**
  ```
  {
    "serviceName": "order-service",
    "processName": "order-create",
    "tenantId": "asferf3r4safasdcd",
    "targetService": [
      {
        "serviceName": "NOTIFICATION_SERVICE",
        "serviceAttributes": {}
      }
    ]
  }
  ```
- **400 Bad Request**
  ```
  {
    "message": "Bad Request"
  }
  ```
- **404 Not Found**
  ```
  {
    "message": "Target Config not Found"
  }
  ```
- **409 Conflict**
  ```
  {
    "message": "Target Config already exists."
  }
  ```
- **500 Internal Server Error**
  ```
  {
    "message": "Internal Server Error"
  }
  ```

### Authorizations

- **Authorization**  
  `Bearer <token>`  
  required: Bearer authentication header of the form `Bearer <token>`, where `<token>` is your auth token.

### Headers

- **x-site-context**  
  required: A JSON object that contains information about the source you wish to pull from. 
  Example:
  ```json
  {"date": "2023-01-01T00:00:00.000Z", "channel": 12, "account": "1234abcd5678efgh9ijklmno","stage":"production"}
  ```

### Body

- **serviceName**  
  required: The name of the service. 
- **processName**  
  required: The name of the process. 
- **targetService**  
  required: Array of target service objects.
